import { Static } from '@sinclair/typebox';
import { FastifyInstance, FastifyServerOptions } from 'fastify';
export declare const PubSubMessage: import("@sinclair/typebox").TObject<{
    message: import("@sinclair/typebox").TObject<{
        attributes: import("@sinclair/typebox").TUnknown;
        data: import("@sinclair/typebox").TString;
        messageId: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TString>;
    }>;
    subscription: import("@sinclair/typebox").TString;
}>;
export declare type PubSubMessageType = Static<typeof PubSubMessage>;
export declare class PubSubHandlerResponse {
    statusCode?: number;
}
export declare type PubSubHandler<T = unknown> = (args: {
    message: PubSubMessageType;
    data?: T;
}) => Promise<PubSubHandlerResponse | void> | PubSubHandlerResponse | void;
export interface PubSubConfig {
    path?: string;
    parseJson?: boolean;
    port?: number;
    address?: string;
    fastifyConfig?: FastifyServerOptions;
}
export interface CreatePubSubHandlerResponse {
    listen: () => Promise<void>;
    fastify: FastifyInstance;
}
export declare function createPubSubHandler<T = unknown>(handler: PubSubHandler<T>, config?: PubSubConfig): CreatePubSubHandlerResponse;
